﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
//import the regular expression library
using System.Text.RegularExpressions;

namespace ValidateRegistrationForm
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

            //initialize the validating method
            static Regex Valid_Fname = StringOnly();
            static Regex Valid_Lname = StringOnly(); 
            static Regex Valid_Contact = NumbersOnly(); 
            static Regex Valid_Password = ValidPassword();
            static Regex Valid_Email = Email_Address();


        
        //Method for validating email address
        private static Regex Email_Address()
        {
            string Email_Pattern = @"^(?!\.)(""([^""\r\\]|\\[""\r\\])*""|"
                + @"([-a-z0-9!#$%&'*+/=?^_`{|}~]|(?<!\.)\.)*)(?<!\.)"
                + @"@[a-z0-9][\w\.-]*[a-z0-9]\.[a-z][a-z\.]*[a-z]$";

            return new Regex(Email_Pattern, RegexOptions.IgnoreCase);
        }
        //Method for string only validation
        private static Regex StringOnly()
        {
            string StringAndNumber_Pattern = "^[a-zA-Z]";

            return new Regex(StringAndNumber_Pattern, RegexOptions.IgnoreCase);
        }
        //Method for numbers only validation
        private static Regex NumbersOnly()
        {
            string StringAndNumber_Pattern = "^[0-9]*$";

            return new Regex(StringAndNumber_Pattern, RegexOptions.IgnoreCase);
        }
        //Method for validating password
        private static Regex ValidPassword()
        {
            string Password_Pattern = "(?!^[0-9]*$)(?!^[a-zA-Z]*$)^([a-zA-Z0-9]{8,15})$";

            return new Regex(Password_Pattern, RegexOptions.IgnoreCase);
        }

        //it validate all textboxes when the button clicked
        private void button1_Click(object sender, EventArgs e)
        {
            //for firstname 
            if (Valid_Fname.IsMatch(txtfName.Text) != true)
            {
                MessageBox.Show("Firstname accepts only alphabetical characters", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtfName.Focus();
                return;
            }
            //for Lastname 
            if (Valid_Lname.IsMatch(txtLname.Text) != true)
            {
                MessageBox.Show("Lastname accepts only alphabetical characters", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtLname.Focus();
                return;
            }
            //for Address 
            if (txtAdd.Text == "")
            {
                MessageBox.Show("Address cannot be empty!", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtAdd.Focus();
                return;
            }
            //for Contacts 
            if (Valid_Contact.IsMatch(txtContact.Text) != true)
            {
                MessageBox.Show("Contact accept numbers only.", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtContact.Focus();
                return;
            }
            //for username 
            if (txtuname.Text == "")
            {
                MessageBox.Show("Username cannot be empty!", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtuname.Focus();
                return;
            }
            //for password 
            if (Valid_Password.IsMatch(txtPass.Text) != true)
            {
                MessageBox.Show("Password must be atleast 8 to 15 characters. It contains atleast one Upper case and numbers.", "Invalid", MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
                txtPass.Focus();
                return;
            }
            //for Email Address 
            if (Valid_Email.IsMatch(txtEmail.Text) != true)
            {
                MessageBox.Show("Invalid Email Address!","Invalid",MessageBoxButtons.OK ,MessageBoxIcon.Exclamation );
                txtEmail.Focus(); 
                return; 
            }

            //success message
          MessageBox.Show("You are now successfully registered.");

            //hidding all object in the form
          foreach(Control txt in this.Controls)
          {
              if (txt is Control)
              {
                  txt.Visible = false;
                 
              }
          }

        
            

        }

 
    }
}
